'ͻ'
' TWINS.BAS                        1.000                         3/ 7/2008 '
'͹'
' Program to Calculate Irreducible Pythagogean Twins.                      '
'Ķ'
' All irreducible Pythagorean Twins are checked and put into a file.       '
'͹'
' Handling:                                                                '
'Ķ'
'  3/ 7/2008 Camil Pogolski, and Norbert Sdland                           '
'͹'
' Translation:                                                             '
'Ķ'
'  3/18/2008 Norbert Sdland                                               '
'ͼ'

'ͻ'
'                                PREPARATION                               '
'ͼ'

  DIM OutputFile%
  DIM Reducible%
  DIM b&, h&
  DIM x&, y&, z&
  DIM xx!, yy!, zz!


'ͻ'
'                                MAIN PART                                 '
'ͼ'

  ON ERROR GOTO ErrorHandling           'This is the first command!
    CLS
    OutputFile% = FREEFILE
100 OPEN "TWINS.LOG" FOR OUTPUT AS #OutputFile%
      b& = 1
      WHILE b& < 46341
110     PRINT #OutputFile%, "b ="; STR$(b&); ":"
        PRINT "b ="; STR$(b&)
        x& = b& + 1
        WHILE x& < 46341
120       y& = x& * x& / 2 / b& - b& / 2
          IF y& > x& THEN
130         z& = y& + b&
140         IF z& * z& - y& * y& = x& * x& THEN
              h& = 2
              Reducible% = 0
              WHILE h& <= b&
                xx! = INT(x& / h&)
                yy! = INT(y& / h&)
                zz! = INT(z& / h&)
                IF zz! * zz! - yy! * yy! = xx! * xx! THEN
                  Reducible% = 1
                  h& = b&
                END IF
                IF h& = 2 THEN
                  h& = 3
                ELSE
                  h& = h& + 2
                END IF
              WEND
              IF Reducible% = 0 THEN
                PRINT #OutputFile%, STR$(z&); "^2 -"; STR$(y&); "^2 =";
                PRINT #OutputFile%, STR$(x&); "^2"
              END IF
            END IF
          END IF
          x& = x& + 1
150     WEND
        PRINT #OutputFile%,
        b& = b& + 1
160   WEND


'==========='
EndOfProgram:
'==========='
    CLOSE       'Will close all opened files.
  SYSTEM        'This is always the last command in a QBASIC program!


'ͻ'
'                              ERROR HANDLING                              '
'ͼ'

'============'
ErrorHandling:
'============'
    SELECT CASE ERR
    CASE 6      'Overflow
      SELECT CASE ERL
      CASE 140
        x& = 46341
        RESUME 150
      CASE ELSE
        PRINT "Error No."; STR$(ERR); " in line"; STR$(ERL)
        STOP
      END SELECT
    CASE ELSE
      PRINT "Error No."; STR$(ERR); " in line"; STR$(ERL)
      STOP
    END SELECT
  ON ERROR GOTO 0       'Jump back to the standard error handling


'ͻ'
'                          SUBROUTINES VIA GOSUB                           '
'ͼ'

'ͻ'
'                         SUBROUTINES AND FUNCTIONS                        '
'ͼ'

